#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <arpa/inet.h>
#include "mqtt.h"

//char TOPIC[18];
//char gsite[18];//网址后缀，使用mac地址

void get_mac_address(const char *iface) {
    int sock;
    struct ifreq ifr;

    sock = socket(AF_INET, SOCK_DGRAM, 0); // 创建套接字
    if (sock < 0) {
        perror("Socket creation failed");
        return;
    }

    strncpy(ifr.ifr_name, iface, IFNAMSIZ - 1); // 指定网络接口
    if (ioctl(sock, SIOCGIFHWADDR, &ifr) < 0) { // 获取硬件地址
        perror("ioctl failed");
        close(sock);
        //return;
    }

    unsigned char *mac = (unsigned char *)ifr.ifr_hwaddr.sa_data;
    printf("MAC address of %s: %02X:%02X:%02X:%02X:%02X:%02X\n",
           iface, mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);

    //sprintf(TOPIC,"%02X:%02X:%02X:%02X:%02X:%02X",mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
    //sprintf(gsite,"https://jywy.yd-ss.com?dev=%02X%02X%02X%02X%02X%02X",mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
    
    
    close(sock); // 关闭套接字
}